//+------------------------------------------------------------------+
//|                                                    Intra_Week.mq4 |
//+------------------------------------------------------------------+
#property copyright " klot & mony "


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Blue
//---- indicator parameters
extern int Hour_Begin_week=21;
extern int Asian_end_hour=7;
extern int Europa_end_hour=15;
extern int ExtDepth=9;
extern int perATR=50;
extern int m=1;
int i0=0;
extern double kkk=0.88;
//---- indicator buffers
int begin,end;
datetime begin_time,end_time,asia_t,amer_t;
double low_asia,high_asia,low_week,high_week,atr;

//-----------------------
double fx[];
double fxH[];
double fxL[];
double a[10,10],b[10],x[10],sx[20];
double sum;
int pp;
int nn;
int bar;
//*******************************************
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
//-------------------------
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,fx);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,fxH);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,fxL);
   nn=m+1;
//---- indicator short name
   IndicatorShortName("Intra_Week");
//---- initialization done

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int deinit()
  {
//----
   obje_del();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    asia_b,i;
   if(Bars<(1440/Period()))return(0);

   datetime _cur_time=iTime(NULL,0,0);
   int      _nbar_week=iBarShift(NULL,PERIOD_W1,_cur_time);

   begin_time=iTime(NULL,PERIOD_W1,_nbar_week)-(120-Hour_Begin_week)*3600;
   begin=iBarShift(NULL,0,begin_time);
   asia_t=iTime(NULL,PERIOD_W1,_nbar_week)+(Asian_end_hour*3600);
   amer_t=iTime(NULL,PERIOD_W1,_nbar_week)+(Europa_end_hour*3600);
   end_time=iTime(NULL,PERIOD_W1,_nbar_week)+(Hour_Begin_week*3600);
   asia_b=iBarShift(NULL,0,asia_t);
   end=iBarShift(NULL,0,end_time);
   //atr=iATR(NULL,PERIOD_W1,perATR,_nbar_week+1);
   atr=0;
   for(i=perATR; i>=1; i--)
     {
      atr+=iHigh(NULL,PERIOD_W1,_nbar_week+i)-iLow(NULL,PERIOD_W1,_nbar_week+i);
     }
   atr=atr/perATR;

   low_asia=Low[Lowest(NULL,0,MODE_LOW,(begin-asia_b),asia_b+1)];
   high_asia=High[Highest(NULL,0,MODE_HIGH,(begin-asia_b),asia_b+1)];

   low_week=High[Highest(NULL,0,MODE_HIGH,begin,0)]-atr;
   high_week=Low[Lowest(NULL,0,MODE_LOW,begin,0)]+atr;

   
   obje_del();
   obje_creat();

   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void obje_del()
  {
   ObjectDelete("Begin");
   ObjectDelete("Asian");
   ObjectDelete("End");
   ObjectDelete("Amer");
   ObjectDelete("Open");
   ObjectDelete("High_asian");
   ObjectDelete("Low_asian");
   ObjectDelete("low_week");
   ObjectDelete("high_week");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void obje_creat()
  {
   
//---------------------
   

   ObjectCreate("low_week",OBJ_TREND,0,Time[0]-900*Period(),low_week,Time[0]+900*Period(),low_week);
   ObjectSet("low_week",OBJPROP_RAY,false);
   ObjectSet("low_week",OBJPROP_COLOR,Green);
   
   ObjectSet("low_week",OBJPROP_WIDTH,5);

   ObjectCreate("high_week",OBJ_TREND,0,Time[0]-900*Period(),high_week,Time[0]+900*Period(),high_week);
   ObjectSet("high_week",OBJPROP_RAY,false);
   ObjectSet("high_week",OBJPROP_COLOR,Blue);
   
   ObjectSet("high_week",OBJPROP_WIDTH,5);
   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void af_Gauss(int n, double& aa[][],double& bb[], double& xx[])
  {
   int i,j,k,l;
   double q,mm,t;

   for(k=1; k<=n-1; k++)
     {
      l=0;
      mm=0;
      for(i=k; i<=n; i++)
        {
         if (MathAbs(aa[i,k])>mm) {mm=MathAbs(aa[i,k]); l=i;}
        }
      if (l==0) return;

      if (l!=k)
        {
         for(j=1; j<=n; j++)
           {
            t=aa[k,j];
            aa[k,j]=aa[l,j];
            aa[l,j]=t;
           }
         t=bb[k];
         bb[k]=bb[l];
         bb[l]=t;
        }

      for(i=k+1;i<=n;i++)
        {
         q=aa[i,k]/aa[k,k];
         for(j=1;j<=n;j++)
           {
            if (j==k) aa[i,j]=0;
            else
               aa[i,j]=aa[i,j]-q*aa[k,j];
           }
         bb[i]=bb[i]-q*bb[k];
        }
     }

   xx[n]=bb[n]/aa[n,n];

   for(i=n-1;i>=1;i--)
     {
      t=0;
      for(j=1;j<=n-i;j++)
        {
         t=t+aa[i,i+j]*xx[i+j];
         xx[i]=(1/aa[i,i])*(bb[i]-t);
        }
     }
   return;
  }
//********************************************************************** 

//+------------------------------------------------------------------+
